<?php

abstract class manufactoryProductAbstract extends manufactoryEntityProduct implements ArrayAccess
{

    protected $storage_objects = array(
        'costs'    => 'manufactoryProductCosts',
        'features' => 'manufactoryProductFeatures',
        'skus'     => 'manufactoryProductSkus',
        'prices'   => 'manufactoryProductPrices',

    );

    public function getType()
    {
        return $this->data['type_id'];
    }

    public function getPrices()
    {
        return $this->getData('prices');
    }

    public function init($data)
    {
        if (is_array($data) && isset($data['id'])) {
            $this->data = $data;
        } elseif (is_numeric($data) && intval($data) > 0) {
            $model = $this->getModel('Product');
            $data = $model->getById($data);
            if (!empty($data)) {
                $this->data = $data;
            }
        }
        foreach ($this->storage_objects as $id => $class) {
            if (class_exists($class)) {
                $this->storage[$id] = new $class($this);
            }
        }
    }

    public function getMinMaxPrice()
    {
        $costs = array();
        foreach ($this->getSkus() as $v) {
            $costs[] = $v->getCost();
        }
        if (count($costs) > 1) {
            sort($costs);

            return array('min' => round(array_shift($costs), 2), 'max' => round(array_pop($costs), 2));
        } else {
            $cost = round(array_shift($costs), 2);

            return array('min' => $cost, 'max' => $cost);
        }
    }

    public function getCost()
    {
        return parent::getCost(); // TODO: Change the autogenerated stub
    }

    public function recalculatePrices($prices = array())
    {
        if (empty($prices)) {
            $prices = manufactoryPricesPool::geByType('generate');
        }
        if (is_array($prices) && !empty($prices)) {
            foreach ($this->getSkus() as $offer) {
                $offer->recalculatePrices($prices);
            }
        }
    }

    public function recalculatePrice($id)
    {
        $prices = array();
        if (is_object($id)) {
            $prices[$id->getId()] = $id;
        } elseif (is_numeric($id)) {
            $prices[$id->getId()] = manufactoryPricesPool::get($id);
        }
        if (!empty($prices)) {
            return $this->recalculatePrices($prices);
        } else {
            return false;
        }
    }

    public function getFeatures()
    {
        return $this->getData('features');
    }

    public function getSkus()
    {
        return $this->getData('skus');
    }

    public function updateProductDatetime($datetime = '')
    {
        if (empty($datetime)) {
            $datetime = date("Y-m-d H:i:s");
        }
        $data = array();
        $data['update_datetime'] = $datetime;
        // save data
        $model = $this->getModel('Product');
        $model->updateById($this->getId(), $data);
    }

    public function save($data)
    {
        if ($this->getId()) {
            $category = new manufactoryCategoryProducts($this->getData('category_id'));
        } else {
            $category = new manufactoryCategoryProducts($data['category_id']);
        }
        if ($category->getRights() < 2) {
            return false;
        }
        // save product data
        $storage_data = array();
        foreach ($this->storage_objects as $k => $item) {
            if (array_key_exists($k, $data)) {
                $storage_data[$k] = $data[$k];
                unset($data[$k]);
            }
        }
        $model = $this->getModel('Product');
        if ($this->getId()) {
            $model->updateById($this->getId(), $data);
            $p_id = $this->getId();
        } else {
            $data['update_datetime'] = $data['create_datetime'] = date("Y-m-d H:i:s");
            $p_id = $model->insert($data);
        }

        $this->setData($model->getById($p_id));
        /// сохранение после создания
        $this->setData($storage_data);
        foreach ($this->storage as $object) {
            if (!method_exists($object, 'save')) {
                throw new waException(get_class($object) . ' not method save');
            }
            $object->save();
        }
        wa()->event('backend_product_save', $this);

        if ($this->change_costs) {
            // Если состав изменился меняем дату обновления продута
            $this->updateProductDatetime();
            ///  а также пересчитываем все нехранимые цены, хранимые обновим в самой цене
            $prices = manufactoryPricesPool::geByType('generate');
            $this->recalculatePrices($prices);
        }
    }

    public function delete()
    {
        $category = new manufactoryCategoryProducts($this->getData('category_id'));
        if ($category->getRights() < 2) {
            return false;
        }
        // Удаляем предложения продукта
        foreach ($this->storage as $object) {
            if (!method_exists($object, 'delete')) {
                throw new waException(get_class($object) . ' not method delete');
            }
            $object->delete();
        }
        // Удаляем сам продукт
        $model = $this->getModel('Product');
        $model->deleteById($this->getId());

        return true;
    }

    abstract public function duplicate();

    public function offsetExists($offset)
    {
        if (isset($this->data[$offset])) {
            return true;
        }

        return false;
    }

    public function offsetGet($offset)
    {
        if (isset($this->data[$offset])) {
            return $this->data[$offset];
        }

        return null;
    }

    public function offsetSet($offset, $value)
    {

        $this->data[$offset] = $value;

    }

    public function offsetUnset($offset)
    {
        $this->data[$offset] = null;
    }
}